## ros-kinetic-toposens-driver 2.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(toposens_driver)

add_compile_options(-std=c++17)

set(${PROJECT_NAME}_DEPS
  dynamic_reconfigure
  message_runtime
  roscpp
  toposens_msgs
)

find_package(catkin REQUIRED COMPONENTS ${${PROJECT_NAME}_DEPS})

find_package(Boost REQUIRED COMPONENTS system)

# ##############################################################################
# Config ##
# ##############################################################################

generate_dynamic_reconfigure_options(cfg/TsDriver.cfg)

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES ${PROJECT_NAME}
  CATKIN_DEPENDS ${${PROJECT_NAME}_DEPS}
)

# ##############################################################################
# Build ##
# ##############################################################################

include_directories(include ${Boost_INCLUDE_DIR} ${catkin_INCLUDE_DIRS})

add_subdirectory(src)

install(
  DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

install(
  DIRECTORY launch param
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

# ##############################################################################
# Test ##
# ##############################################################################

if(CATKIN_ENABLE_TESTING)
  add_subdirectory(tests)
endif()

=== src/CMakeLists.txt ===
#############
## Library ##
#############

add_library(
  ${PROJECT_NAME}
  lib/command.cpp
  lib/sensor.cpp
  lib/serial.cpp
)

add_dependencies(
  ${PROJECT_NAME}
  ${PROJECT_NAME}_gencfg
  ${catkin_EXPORTED_TARGETS}
)

target_link_libraries(
  ${PROJECT_NAME}
  ${catkin_LIBRARIES}
)

install(
  TARGETS ${PROJECT_NAME}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
)


################
## Executable ##
################

add_executable(
  ${PROJECT_NAME}_node
  ts_driver_node.cpp
)

target_link_libraries(
  ${PROJECT_NAME}_node
  ${PROJECT_NAME}
)

install(
  TARGETS ${PROJECT_NAME}_node
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  COMPONENT main
)

=== tests/CMakeLists.txt ===
find_package(roslaunch REQUIRED)
find_package(rostest REQUIRED)

set(TEST_DATA_LOCATION
  http://24.134.186.113:3999/ros_testing
)

add_definitions(
  -Wall
  -O2
  -D_GNU_SOURCE
  -Wno-unused-but-set-variable
  -Wno-unused-result
  -Wno-conversion-null
)

###############
## Emulation ##
###############

add_executable(
  ${PROJECT_NAME}_mock
  tty_emulator/tty0tty.c
)

install(
  TARGETS ${PROJECT_NAME}_mock
  RUNTIME DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

#@todo can we just execute emulator here directly, have all tests run
# and kill the process later?

###############
## Data Dump ##
###############

if(PLUGGED_IN)
  set(LOG_PERIOD 3s)
  set(PORT /dev/ttyUSB0)

  #@todo for launch file to work, the node executable needs to be first built
  # see if you can issue a post build command instead
  # or make sure catkin_make has been called before the run_tests

  message(STATUS "Extracting data from live stream for ${LOG_PERIOD}")
  execute_process(
    COMMAND timeout ${LOG_PERIOD}
            roslaunch ${PROJECT_NAME} ${PROJECT_NAME}.launch
    COMMAND timeout ${LOG_PERIOD}
            cat ${PORT}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    OUTPUT_FILE raw_stream
  )
  message(STATUS "Raw stream extraction complete")

endif()


########################
## Download Test Data ##
########################


catkin_download_test_data(
  ${PROJECT_NAME}_raw_stream
  ${TEST_DATA_LOCATION}/raw_stream
  DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/tests
  MD5 3ec2f56b1cf5372cc98499c4458d37ff
)

catkin_download_test_data(
  ${PROJECT_NAME}_ts_scans.bag
  ${TEST_DATA_LOCATION}/ts_scans.bag
  DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/tests
  MD5 1fa17f252671369fa754e5e0736dbb7c
)


#############
## Modules ##
#############

set(TEST_MODULES
  command
  sensor
  serial
)

foreach(M ${TEST_MODULES})

  add_rostest_gtest(
    ${PROJECT_NAME}_${M}_test
    modules/${M}/launch.test
    modules/${M}/tests.cpp
  )

  add_dependencies(
    ${PROJECT_NAME}_${M}_test
    ${PROJECT_NAME}_mock
    ${PROJECT_NAME}_node
  )

  target_link_libraries(
    ${PROJECT_NAME}_${M}_test
    ${PROJECT_NAME}
  )
endforeach()

#############
## Hz test ##
#############

add_rostest(
  hertz/ts_scans.test
  DEPENDENCIES ${PROJECT_NAME}_node
)

=== debian/changelog ===
ros-kinetic-toposens-driver (2.2.0-3xenial) xenial; urgency=high

  * Optimize launch file structure
  * Add .clang-format file and auto-format files (including XML-style files)
  * Remove reconfig unit/integration tests from packages toposens_driver and
    toposens_markers
  * Bugfix: Install param/ folder
  * Contributors: Dennis Maier, Tobias Roth

 -- Tobias Roth <roth@toposens.com>  Wed, 10 Feb 2021 23:00:00 -0000

ros-kinetic-toposens-driver (2.1.1-3xenial) xenial; urgency=high



 -- Tobias Roth <roth@toposens.com>  Mon, 23 Nov 2020 23:00:00 -0000

ros-kinetic-toposens-driver (2.1.0-3xenial) xenial; urgency=high

  * Introduce bringup package and general updates.
  * Prepare for Noetic release
  * Run separate CI stages for melodic+noetic. Bump up CMake version to 3.0.2.
  * Contributors: Tobias Roth

 -- Tobias Roth <roth@toposens.com>  Mon, 02 Nov 2020 23:00:00 -0000

ros-kinetic-toposens-driver (2.0.4-3xenial) xenial; urgency=high

  * Changed package maintainer
  * Fix catkin_lint issues
  * Contributors: Tobias Roth

 -- Tobias Roth <roth@toposens.com>  Wed, 14 Oct 2020 22:00:00 -0000

ros-kinetic-toposens-driver (2.0.3-3xenial) xenial; urgency=high

  * Added param directory to install
  * Changed address of server for testing files
  * Contributors: Sebastian Dengler

 -- Sebastian Dengler <dengler@toposens.com>  Tue, 11 Aug 2020 22:00:00 -0000

ros-kinetic-toposens-driver (2.0.2-3xenial) xenial; urgency=high

  * Changed package maintainer
  * Contributors: Sebastian Dengler

 -- Sebastian Dengler <dengler@toposens.com>  Thu, 27 Feb 2020 23:00:00 -0000

ros-kinetic-toposens-driver (2.0.1-3xenial) xenial; urgency=high



 -- Adi Singh <singh@toposens.com>  Wed, 22 Jan 2020 23:00:00 -0000

ros-kinetic-toposens-driver (2.0.0-3xenial) xenial; urgency=high



 -- Adi Singh <singh@toposens.com>  Mon, 13 Jan 2020 23:00:00 -0000

ros-kinetic-toposens-driver (1.3.0-3xenial) xenial; urgency=high



 -- Adi Singh <singh@toposens.com>  Sun, 17 Nov 2019 23:00:00 -0000

ros-kinetic-toposens-driver (1.2.3-3xenial) xenial; urgency=high



 -- Adi Singh <singh@toposens.com>  Mon, 02 Sep 2019 22:00:00 -0000

ros-kinetic-toposens-driver (1.2.2-3xenial) xenial; urgency=high

  * Baudrate changed to 576000 to match TS3 firmware version 13
  * Firmware version displayed at startup
  * Contributors: Andrej Wallwitz, Georgiana Barbut

 -- Adi Singh <singh@toposens.com>  Thu, 01 Aug 2019 22:00:00 -0000

ros-kinetic-toposens-driver (1.2.1-3xenial) xenial; urgency=high



 -- Adi Singh <singh@toposens.com>  Thu, 11 Jul 2019 22:00:00 -0000

ros-kinetic-toposens-driver (1.2.0-3xenial) xenial; urgency=high

  * Added support for armhf architectures
  * Added rules to install launch files
  * Contributors: Christopher Lang, Sebastian Dengler

 -- Adi Singh <singh@toposens.com>  Thu, 04 Jul 2019 22:00:00 -0000

ros-kinetic-toposens-driver (1.1.0-3xenial) xenial; urgency=high



 -- Adi Singh <singh@toposens.com>  Thu, 20 Jun 2019 22:00:00 -0000

ros-kinetic-toposens-driver (1.0.0-3xenial) xenial; urgency=high

  * Added setup delay to Hz tests
  * Contributors: Adi Singh, Christopher Lang, Sebastian Dengler

 -- Adi Singh <singh@toposens.com>  Mon, 13 May 2019 22:00:00 -0000

ros-kinetic-toposens-driver (0.9.6-3xenial) xenial; urgency=high

  * Add colored tags to tests for console debugging
  * Added sensor mesh to PCL rviz
  * Removed pointcloud dependency on rviz
  * Implemented test data download functionality
  * Contributors: Adi Singh, Roua Mokchah

 -- Adi Singh <singh@toposens.com>  Sun, 12 May 2019 22:00:00 -0000

ros-kinetic-toposens-driver (0.9.5-3xenial) xenial; urgency=high

  * Implemented tests for dynamic reconfig
  * Implemented tests for toposens_pointcloud
  * Contributors: Adi Singh, Roua Mokchah

 -- Adi Singh <singh@toposens.com>  Thu, 02 May 2019 22:00:00 -0000

ros-kinetic-toposens-driver (0.9.3-3xenial) xenial; urgency=high

  * Added automated tests for toposens_markers
  * Contributors: Adi Singh, Roua Mokchah

 -- Adi Singh <singh@toposens.com>  Thu, 25 Apr 2019 22:00:00 -0000

ros-kinetic-toposens-driver (0.9.2-3xenial) xenial; urgency=high

  * Fixed package versions
  * Added Docker config file
  * Contributors: Adi Singh

 -- Adi Singh <singh@toposens.com>  Tue, 16 Apr 2019 22:00:00 -0000

ros-kinetic-toposens-driver (0.9.0-3xenial) xenial; urgency=high

  * Integrated with turtlebot packages
  * Linted cmake files
  * Contributors: Adi Singh, Nancy Seckel

 -- Adi Singh <singh@toposens.com>  Mon, 08 Apr 2019 22:00:00 -0000

ros-kinetic-toposens-driver (0.8.1-3xenial) xenial; urgency=high

  * Added gitlab CI config
  * Added remote Turtlebot launchers
  * Pointcloud instructions added to README.md
  * Temperature calibration implemented
  * Contributors: Adi Singh, Andrej Wallwitz, Nancy Seckel, Sebastian Dengler

 -- Adi Singh <singh@toposens.com>  Thu, 28 Mar 2019 23:00:00 -0000

ros-kinetic-toposens-driver (0.8.0-3xenial) xenial; urgency=high

  * Added driver documentation
  * Created Command class with overloaded constructors
  * Contributors: Adi Singh, Christopher Lang

 -- Adi Singh <singh@toposens.com>  Thu, 07 Mar 2019 23:00:00 -0000

ros-kinetic-toposens-driver (0.7.0-3xenial) xenial; urgency=high

  * Added native PCL integration
  * Implemented markers using rviz visual tools
  * Added dynamic reconfigure capability for driver
  * Refactored to standard ROS package template
  * Contributors: Adi Singh

 -- Adi Singh <singh@toposens.com>  Tue, 26 Feb 2019 23:00:00 -0000

ros-kinetic-toposens-driver (0.5.0-3xenial) xenial; urgency=high



 -- Adi Singh <singh@toposens.com>  Wed, 06 Feb 2019 23:00:00 -0000

=== debian/control ===
Source: ros-kinetic-toposens-driver
Section: misc
Priority: optional
Maintainer: Tobias Roth <roth@toposens.com>
Build-Depends: debhelper (>= 9.0.0), ros-kinetic-catkin, ros-kinetic-dynamic-reconfigure, ros-kinetic-message-runtime, ros-kinetic-roscpp, ros-kinetic-roslaunch, ros-kinetic-rostest, ros-kinetic-toposens-msgs
Homepage: https://toposens.com
Standards-Version: 3.9.2

Package: ros-kinetic-toposens-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-kinetic-dynamic-reconfigure, ros-kinetic-message-runtime, ros-kinetic-roscpp, ros-kinetic-toposens-msgs
Description: ROS device driver for communication with TS sensors.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-toposens-driver//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
